﻿#include "Log.h"
#include <spdlog/logger.h>

#include <spdlog/sinks/stdout_color_sinks.h>

std::shared_ptr<spdlog::logger> WinDevice::Log::logger = nullptr;

void WinDevice::Log::Init(LogLevel level, std::string fileName)
{
    logger = spdlog::stdout_color_mt("console");
    logger->set_level(static_cast<spdlog::level::level_enum>(level));
    logger->set_pattern("[%H:%M:%S %z] [%n] [%^---%L---%$] [thread %t] %v");
//    spdlog::set_level(static_cast<spdlog::level::level_enum>(level)); // 设置日志级别为 debug
//	spdlog::set_pattern("[%H:%M:%S %z] [%n] [%^---%L---%$] [thread %t] %v");
}

void WinDevice::Log::debug(std::string format)
{
    logger->debug(format);
}

void WinDevice::Log::debug(std::string format, std::string args...)
{
    logger->debug(format, args);
}

void WinDevice::Log::debugW(std::wstring format, std::wstring args...)
{
    logger->debug(format, args);
}

void WinDevice::Log::info(std::string format)
{
    logger->info(format);
}

void WinDevice::Log::info(std::string format, std::string args...)
{
    logger->info(format, args);
}

void WinDevice::Log::infoW(std::wstring format, std::wstring args...)
{
    logger->info(format, args);
}

void WinDevice::Log::warn(std::string format)
{
    logger->warn(format);
}

void WinDevice::Log::warn(std::string format, std::string args...)
{
    logger->warn(format, args);
}

void WinDevice::Log::warnW(std::wstring format, std::wstring args...)
{
    logger->warn(format, args);
}

void WinDevice::Log::error(std::string format)
{
    logger->error(format);
}

void WinDevice::Log::error(std::string format, std::string args...)
{
    logger->error(format, args);
}

void WinDevice::Log::errorW(std::wstring format, std::wstring args...)
{
    logger->error(format, args);
}
