﻿#pragma once
#include "spdlog/spdlog.h"
#include "spdlog/spdlog.h"
#include "spdlog/sinks/stdout_sinks.h"
#include <spdlog/sinks/stdout_color_sinks.h>

#define LOG_FUNC_START() spdlog::info("=====> {0} start <=====", __FUNCTION__)
#define LOG_FUNC_END() spdlog::info("=====> {0} end <=====", __FUNCTION__)

namespace WinDevice {
    enum LogLevel : int
    {
        Debug = spdlog::level::debug,
        Info = spdlog::level::info,
    };

    class Log
    {
    public:
        static void Init(LogLevel level, std::string fileName);

        static void debug(std::string format);
        static void debug(std::string format, std::string args...);
        static void debugW(std::wstring format, std::wstring args...);

        static void info(std::string format);
        static void info(std::string format, std::string args...);
        static void infoW(std::wstring format, std::wstring args...);

        static void warn(std::string format);
        static void warn(std::string format, std::string args...);
        static void warnW(std::wstring format, std::wstring args...);

        static void error(std::string format);
        static void error(std::string format, std::string args...);
        static void errorW(std::wstring format, std::wstring args...);
        
    private:
        static std::shared_ptr<spdlog::logger> logger;
    };
}

