﻿//
// Created by zyz on 2024/9/30.
//
#include <WTypesbase.h>
#include <Pdh.h>
#include <PdhMsg.h>
#include <vector>
#include <string>

#ifndef WINDEVICE_PERFORMANCETOOL_H
#define WINDEVICE_PERFORMANCETOOL_H

namespace WinDevice {
    
    struct AppUsageInfo {
        DWORD processId;
        std::string processName;
        float cpuUsage;
        float memoryUsage;
    };
    
    class PerformanceTool {
    public: 
        PerformanceTool();
        ~PerformanceTool();
        float GetAppCpuUsage(DWORD processId);
        float GetAppCpuUsage(const std::wstring& processName);
        float GetAppMemoryUsage(DWORD processId);
        float GetAppMemoryUsage(const std::wstring& processName);
//        float GetCurrentAppCpuUsage();
//        float GetCurrentAppMemoryUsage();
//        WinDevice::AppUsageInfo GetCurrentAppUsage();
//        WinDevice::AppUsageInfo GetAppUsage(DWORD processId);
//        WinDevice::AppUsageInfo GetAppUsage(const std::wstring& processName);
//        std::vector<WinDevice::AppUsageInfo> GetTopAppUsageInfo(int topCount);
//        float GetTotalCpuUsage() const;
//        float GetTotalMemoryUsage() const;
        
    private:
        float _GetAppCpuUsage(DWORD processId, const std::wstring &processName);
        float _GetAppMemoryUsage(const std::wstring &processName);
        std::wstring _GetProcessName(DWORD processId);
        DWORD _GetProcessId(const std::wstring &processName);
    };
}

#endif //WINDEVICE_PERFORMANCETOOL_H
